<?php
/**
*
* I'm request you retain the copyright notice below including the link to site author.
* @package phpBB3
* @version $Id: ajax_thanks.php, v 1.0.0 2010/11/27 01:10:26 Porutchik Exp $
* @copyright (c) 2010 Sergey aka Porutchik, http://forum.aeroion.ru
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
// specify styles and/or localisation
$user->setup('viewtopic');

if ($user->data['is_bot'])
{
	send_status_line(403, 'Forbidden');
	trigger_error($user->lang['LINKAGE_FORBIDDEN']);
}

$auth_admin = ($user->data['user_type'] == USER_FOUNDER || $auth->acl_get('a_attach'));

$attach_id = request_var('id', 0);
$full_window = utf8_normalize_nfc(request_var('full_window', '', true));
$start = request_var('start', 0);
$start = (intval($start) < 0) ? 0 : intval($start);

if (!$attach_id)
{
	trigger_error('NO_ATTACHMENT_SELECTED');
}

if (!$auth_admin && !$config['allow_attachments'])
{
	trigger_error('ATTACHMENT_FUNCTIONALITY_DISABLED');
}

$sql = 'SELECT attach_id, in_message, real_filename, topic_id, post_msg_id
	FROM ' . ATTACHMENTS_TABLE . "
	WHERE attach_id = $attach_id";
$result = $db->sql_query_limit($sql, 1);
$attachment = $db->sql_fetchrow($result);
$db->sql_freeresult($result);

if (!$attachment)
{
	trigger_error('ERROR_NO_ATTACHMENT');
}

if ((!$attachment['in_message'] && !$config['allow_attachments']) || $attachment['in_message'])
{
	trigger_error('ATTACHMENT_FUNCTIONALITY_DISABLED');
}

//
// Start auth check
//
if (!$auth_admin)
{
	// get forum_id for attachment authorization
	$row = array();
	
	//
	$sql = 'SELECT p.forum_id, f.forum_password, f.parent_id
		FROM ' . POSTS_TABLE . ' p, ' . FORUMS_TABLE . ' f
		WHERE p.post_id = ' . $attachment['post_msg_id'] . '
			AND p.forum_id = f.forum_id';
	$result = $db->sql_query_limit($sql, 1);
	$row = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);
	
	// Global announcement?
	$f_download = (!$row) ? $auth->acl_getf_global('f_download') : $auth->acl_get('f_download', $row['forum_id']);
	
	if ($auth->acl_get('u_download') && $f_download)
	{
		if ($row && $row['forum_password'])
		{
			// Do something else ... ?
			login_forum_box($row);
		}
	}
	else
	{
		trigger_error('SORRY_AUTH_VIEW_ATTACH');
	}
}
//
// End auth check
//

//
// Generate the page
//

// Output page
page_header($user->lang['ATTACH_WHO_DOWNLOADED'], false);

$sql = 'SELECT count(*) AS total
	FROM ' . DOWNLOAD_ATTACH_TABLE . '
	WHERE attach_id = ' . (int) $attachment['attach_id'];

$result = $db->sql_query($sql);
$total_rows = (int) $db->sql_fetchfield('total');
$db->sql_freeresult($result);

$sql_limit = $config['topics_per_page'];
$sql_start = $start;

$template->set_filenames(array(
	'body' => 'downloadslist_body.html')
);

// If we've got a hightlight set pass it on to pagination.
$pagination = generate_pagination(append_sid("{$phpbb_root_path}downloads_list.$phpEx", 'id=' . $attachment['attach_id'] . "&amp;full_window=$full_window"), $total_rows, $sql_limit, $sql_start);

$template->assign_vars(array( 
	'ATTACH_NAME' => $attachment['real_filename'],
	'TOTAL_ROW' 	=> $total_rows,
	'PAGE_NUMBER' 	=> on_page($total_rows, $config['topics_per_page'], $start),
	'PAGINATION' 	=> $pagination,
	'S_AUTH_ADMIN' 	=> $auth_admin,
	'S_FULL_WINDOW' => $full_window,
	)
);

//
// Retreive the username, user id and the time
//
$sql = 'SELECT u.username, u.user_id, u.user_colour, a.date, a.user_ip, a.referer
	FROM ' . DOWNLOAD_ATTACH_TABLE . ' a, ' . USERS_TABLE . ' u
	WHERE a.attach_id = ' . (int) $attachment['attach_id'] . '
		AND a.user_id = u.user_id
	ORDER BY a.date DESC';

$result = $db->sql_query_limit($sql, $sql_limit, $sql_start);

$downloaded_row = $db->sql_fetchrowset($result);
$db->sql_freeresult($result);
$total_rows = sizeof($downloaded_row);

for ( $i = 0; $i < $total_rows; $i++ )
{
	$row_num = ($start + $i + 1); 
	$username = ($downloaded_row[$i]['user_id'] == ANONYMOUS) ? $user->lang['GUEST'] : get_username_string('full', $downloaded_row[$i]['user_id'], $downloaded_row[$i]['username'], $downloaded_row[$i]['user_colour'], $downloaded_row[$i]['username']);
	$template->assign_block_vars('downloaded_row', array(
		'ROW_NUMBER' => $row_num,
		'USER' => $username,
		'DATE' => $user->format_date($downloaded_row[$i]['date']),
	));
	if ($auth_admin) 
	{ 
		$template->assign_block_vars('downloaded_row.admin', array(
			'USER_IP' => $downloaded_row[$i]['user_ip'],
			'REFERER' => $downloaded_row[$i]['referer'])
		);
	}
}

page_footer();

?>